/*
 * Copyright (c) 2007 Takuya SHIOZAKI <tshiozak@bsdclub.org>,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef COPYLEFT_VST_H_
#define COPYLEFT_VST_H_

#include <public.sdk/source/vst2.x/audioeffectx.h>

class CopyLeftVST : public AudioEffectX
{
public:
	CopyLeftVST(audioMasterCallback);
	~CopyLeftVST();
	//
	void setProgram(VstInt32);
	void setProgramName(char *);
	void getProgramName(char *);
	void getParameterLabel(VstInt32, char *);
	void getParameterDisplay(VstInt32, char *);
	void getParameterName(VstInt32, char *);
	void setParameter(VstInt32, float value);
	float getParameter(VstInt32);
	bool getProgramNameIndexed(VstInt32, VstInt32, char *);
	bool getOutputProperties(VstInt32, VstPinProperties *);
	bool getInputProperties(VstInt32, VstPinProperties *);

	bool getEffectName(char *);
	bool getVendorString(char *);
	bool getProductString(char *);

	VstInt32 getVendorVersion();
	//
	void processReplacing(float **, float **, VstInt32);
	void processDoubleReplacing(double **, double **, VstInt32);
};

#endif
